# Laplace transform inverse

require 'linalg'  #....... linalg-1.0.0-i386-mswin32-ruby18
include Linalg

class Laplas
   def initialize(param)
	  @param=param
   end
 
# first mode 
   def obras
    si=@param["si"]; t=@param["t"]; fi=@param["fi"]
	nk=fi.size
	  it,a,f=0,[],[]
	  t.each do |t|
		 r=Math.acos(Math.exp(-si*t))
	     (0...nk).each do |n| a[n]=Math.sin((2*n+1)*r); end
		 f[it]=0; kof1=1
		 for i in 0...nk
		    k=0; kof=1
		    (i...nk).each do |n| k+=kof*a[n]; kof*=-(n+i+1.0)/(n-i+1); end
		    f[it]+=kof1*k*fi[i]
			kof1*=4
		 end
	  f[it]*=4*si/Math::PI
	  it+=1					
	  end
	f
	end

# second mode	
	def obrasap
		si=@param["si"]; t=@param["t"]; fi=@param["fi"]
		nk=fi.size; nt=t.size
		f=[]
		for k in 0...nt
			m=DMatrix.new(nk,nk)
			b=DMatrix.new(nk,1)
			da=0.01   # da : arbitrary parameter
			for i in 0...nk
				a=da*i
				b[i]=Math.sin(a*t[k])+Math.cos(a*t[k]) 
				     #............ approximating function (arbitrary)
				for j in 0...nk
					s=(2*j+1.0)*si
					m[i,j]=(a+s)/(s*s+a*a) 
					 #............ sin(at) + cos(at) <-- (a+s)/(s*s+a*a)
				end
			end
			q=DMatrix::solve(m,b)
			f[k]=0
			(0...nk).each { |i| f[k]+=q[i]*fi[i] }
		end
		f
	end

end




