require 'laplas'
require 'grafik'
# example 1.

tk,dt,nk,si,t,fi=10,0.1,30,0.3,[],[]    # nk, si : arbitrary parameters
(0...tk/dt).each do |i| t[i]=dt*(i+1); end


(0...nk).each { |i| s=(2*i+1.0)*si; fi[i]=Math.exp(-5*s)/s; }
         #......... fi(s) = exp(-s)/s ---> f(t) = if t < 1 0 else 1
param={"t" => t, "fi" => fi, "si" => si} # random order
f=Laplas.new(param).obras

(0...tk/dt).each do |i| printf("t= %4.2f  ",t[i]);
printf("f(t)= %7.4f\n", f[i]); end

rasmerx=800; rasmery=600; 
   f1=Array.new(tk/dt) {|i| if t[i]>5 then 1.0 else 0 end}		
a=Grafik.new(rasmerx,rasmery,t,f1,f).graph

